#!/bin/sh
#
#
PATH="$PATH"
_IFS="$IFS"
#----------------------------------------------------------------------
# Note <string> ...
Note ()
{
#	if [ "@$1" = "@-n" ]; then
#		shift
#		echo -n "$*" 1>&2
#	else
		echo "$*" 1>&2
#	fi
}
#----------------------------------------------------------------------
# YesNo <string> ...
#	0	if yes
#	-1	if no
YesNo ()
{
	while true; do
		Note "$* [y/n]"
		read y
		if [ "@$y" = "@y" ]; then
			return 0
		elif [ "@$y" = "@n" ]; then
			return 1
		fi
	done
}
#----------------------------------------------------------------------
# AskFor <text> <var>
# Sets <var> to the new entered value or leave it unchanged, if nothing
# has been entered
AskFor ()
{
	eval echo "$1 [\$$2]:"
	read y
	if [ "@$y" != "@" ]; then
		eval $2="$y"
	fi
}
#----------------------------------------------------------------------
# SaveConfig
# Saves the current configuration into .config.save
SaveConfig ()
{
	Note "Saving the configuration..."
	cat > .config.cache <<EOF-EOF-EOF
LS_DB_LOCATION="$LS_DB_LOCATION"
ALIASES_DATA_BASE="$ALIASES_DATA_BASE"
EOF-EOF-EOF
}

#----------------------------------------------------------------------
# GetOs
# Determines the used operating system. Sets MACHIN to <vender-os>
GetOs ()
{
	Note "checking for system type: "
	REL=`uname -r`
	IFS='.'
	set $REL
	IFS="$_IFS"
	case `uname -s` in
		SunOS)	MACHINE=sun-sunos; ARCH=sun$1;;
		AIX)	MACHINE=ibm-aix; ARCH=ibm$1;;
		Linux)  MACHINE=x86-pc; ARCH=pc;;
		*)	Note "Sorry, unknown system type"; kill -1 $$;;
	esac
	Note $MACHINE $ARCH
}
#----------------------------------------------------------------------
MakeSedScript ()
{
	cat > dummy.sed << EOF-EOF-EOF
/@ECHO@/s;;$ECHO;g
/@LS_DB_LOCATION@/s;;$LS_DB_LOCATION;g
/@ALIASES_DATA_BASE@/s;;$ALIASES_DATA_BASE;g
/@MINT_DIR@/s;;$MINT_DIR;g
/@MINT_ETC@/s;;$MINT_ETC;g
/@MINT_AUDIO@/s;;$MINT_AUDIO;g
/@MINT_BIN@/s;;$MINT_BIN;g
/@WARNING@/s;;WARNING: This file was automatically created by the MINT configure script!;g
EOF-EOF-EOF
}
######################################################################
# main ()

echo "Multimedia InternetTerminal  Installation script"
echo "------------------------------------------------------"
echo ""
echo "This script will install the Multimedia Internet Terminal (Mint) 2.0 Beta1 "
echo "on your computer."
echo ""

### Set some useful defaults

MINT_DIR=`pwd`
MINT_ETC="$MINT_DIR/etc"
MINT_AUDIO="$MINT_DIR/etc"
MINT_BIN="$MINT_DIR/bin"
LS_DB_LOCATION="/export/ls-db"
ALIASES_DATA_BASE=/etc/mail/aliases
NAMEMAPPER_PATH="$MINT_BIN"
ECHO="echo"

JUNK="
	dummy.sed
"

# read values from previous installation attempt
  if [ -r ./.config.cache ]; then
	. ./.config.cache
  fi

### Checking for some things...

#  if [ -x `which uname` ]; then	
#  	echo "checking whether your operating system is supported..."
#  	case `uname -s` in
#    	  Linux)       ;;
#    	  SunOS)    ;;
#    	  *)             { echo "Your OS is not supported. Aborting"; exit 1; };;
#  	esac 
#  	echo "OK."
#  fi
	
  echo "---------------------"

  AskFor "NFS directory for location database service" LS_DB_LOCATION
  AskFor "Aliases database" ALIASES_DATA_BASE

  MINT_BIN="$MINT_DIR/bin"
  MINT_ETC="$MINT_DIR/etc"
  MINT_AUDIO="$MINT_DIR/etc"

  MakeSedScript
  FILES="
    etc/mailcap
    etc/start_isc
    etc/system.sipdrc
    etc/start_sipd
    user-install.sh
  "

  for f in $FILES; do
   echo "creating $f from $f.in"
   rm -f $f
   sed -f dummy.sed <$f.in >$f
   chmod 0755 $f
  done

# save the new configuration
  SaveConfig

  \rm -f $JUNK
